package atomfeed

import (
	"errors"
	"fmt"
)

type Icon struct {
	*CommonAttributes
	URI IRI `xml:"uri"`
}

func NewIcon(uri string) *Icon {
	return &Icon{URI: IRI(uri)}
}

func (i *Icon) Check() error {
	if i.URI == "" {
		return errors.New("uri element of icon empty")
	} else {
		if !isValidIRI(i.URI) {
			return fmt.Errorf("uri attribute %v of icon not correctly formatted", i.URI)
		}
	}

	return nil
}
