package atomfeed

import (
	"errors"
	"fmt"

	"github.com/google/uuid"
)

type ID struct {
	*CommonAttributes
	URI IRI `xml:"uri"`
}

func NewID() *ID {
	return &ID{URI: IRI(fmt.Sprint("urn:uuid:", uuid.New()))}
}

func (i *ID) Check() error {
	if i.URI == "" {
		return errors.New("uri element of id empty")
	} else {
		if !isValidIRI(i.URI) {
			return fmt.Errorf("uri element %v of id not correctly formatted", i.URI)
		}
	}

	return nil
}
